import { defineComponent, toRefs, ref, watch, onMounted, openBlock, createBlock, resolveDynamicComponent, mergeProps, withCtx, createElementVNode, normalizeStyle, renderSlot, createElementBlock, resolveComponent, createVNode, createCommentVNode, computed, unref, onBeforeUnmount, withModifiers, normalizeClass, reactive } from "vue";
import octicons from "@primer/octicons";
var ActionListItem_vue_vue_type_style_index_0_scoped_true_lang = "";
var _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const _hoisted_1$5 = { class: "ActionList-item-action ActionList-item-action--leading" };
const _sfc_main$6 = /* @__PURE__ */ defineComponent({
  props: {
    modelValue: {
      type: Boolean
    }
  },
  emits: [
    "update:modelValue"
  ],
  setup(__props, { emit }) {
    const props = __props;
    const { modelValue } = toRefs(props);
    const detailsRef = ref();
    function get() {
      var _a;
      return Boolean((_a = detailsRef.value) == null ? void 0 : _a.open);
    }
    function set(isOpen) {
      var _a, _b;
      if (isOpen) {
        (_a = detailsRef.value) == null ? void 0 : _a.setAttribute("open", true);
      } else {
        (_b = detailsRef.value) == null ? void 0 : _b.removeAttribute("open");
      }
    }
    watch(modelValue, set);
    onMounted(() => set(modelValue.value));
    function handleToggle() {
      emit("update:modelValue", get());
    }
    return (_ctx, _cache) => {
      return openBlock(), createBlock(resolveDynamicComponent(_ctx.$slots.children ? "details" : "li"), mergeProps({
        ref_key: "detailsRef",
        ref: detailsRef
      }, _ctx.$attrs, {
        class: "ActionList-item",
        style: { listStylePosition: "inside" },
        onToggle: handleToggle
      }), {
        default: withCtx(() => [
          (openBlock(), createBlock(resolveDynamicComponent(_ctx.$slots.children ? "summary" : "div"), { class: "ActionList-content" }, {
            default: withCtx(() => [
              createElementVNode("span", _hoisted_1$5, [
                createElementVNode("span", {
                  class: "disclosureArrow",
                  style: normalizeStyle({ opacity: _ctx.$slots.children ? void 0 : 0 })
                }, null, 4)
              ]),
              renderSlot(_ctx.$slots, "default", {}, void 0, true)
            ]),
            _: 3
          })),
          renderSlot(_ctx.$slots, "children", {}, void 0, true)
        ]),
        _: 3
      }, 16);
    };
  }
});
var ActionListItem = /* @__PURE__ */ _export_sfc(_sfc_main$6, [["__scopeId", "data-v-b257246c"]]);
const _hoisted_1$4 = ["width", "height"];
const _hoisted_2$2 = ["stroke-width"];
const _hoisted_3$1 = ["stroke-width"];
const _sfc_main$5 = /* @__PURE__ */ defineComponent({
  props: {
    size: {
      type: Number,
      default: 16
    },
    thickness: {
      type: Number,
      default: 2
    }
  },
  setup(__props) {
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("svg", {
        style: { "box-sizing": "content-box", "color": "var(--color-icon-primary)" },
        width: __props.size,
        height: __props.size,
        viewBox: "0 0 16 16",
        fill: "none",
        "data-view-component": "true",
        class: "anim-rotate"
      }, [
        createElementVNode("circle", {
          cx: "8",
          cy: "8",
          r: "7",
          stroke: "currentColor",
          "stroke-opacity": "0.25",
          "stroke-width": __props.thickness,
          "vector-effect": "non-scaling-stroke"
        }, null, 8, _hoisted_2$2),
        createElementVNode("path", {
          d: "M15 8a7.002 7.002 0 00-7-7",
          stroke: "currentColor",
          "stroke-width": __props.thickness,
          "stroke-linecap": "round",
          "vector-effect": "non-scaling-stroke"
        }, null, 8, _hoisted_3$1)
      ], 8, _hoisted_1$4);
    };
  }
});
var Button_vue_vue_type_style_index_0_scoped_true_lang = "";
const _sfc_main$4 = defineComponent({
  name: "Button",
  components: {
    Spinner: _sfc_main$5
  },
  props: {
    loading: {
      type: Boolean,
      default: false
    }
  }
});
const _hoisted_1$3 = {
  key: 0,
  class: "Button-spinner"
};
function _sfc_render$2(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_Spinner = resolveComponent("Spinner");
  return openBlock(), createElementBlock("button", mergeProps({ type: "button" }, _ctx.$attrs, { class: "Button btn" }), [
    createElementVNode("div", {
      class: "Button-content",
      style: normalizeStyle({ opacity: _ctx.loading ? 0 : void 0 })
    }, [
      renderSlot(_ctx.$slots, "default", {}, void 0, true)
    ], 4),
    _ctx.loading ? (openBlock(), createElementBlock("div", _hoisted_1$3, [
      createVNode(_component_Spinner)
    ])) : createCommentVNode("", true)
  ], 16);
}
var Button = /* @__PURE__ */ _export_sfc(_sfc_main$4, [["render", _sfc_render$2], ["__scopeId", "data-v-2b0a6080"]]);
const _hoisted_1$2 = ["innerHTML"];
const _sfc_main$3 = /* @__PURE__ */ defineComponent({
  props: {
    name: {
      type: String,
      required: true
    },
    size: {
      type: Number,
      default: 16,
      validator(v) {
        return [12, 16, 24].includes(v);
      }
    }
  },
  setup(__props) {
    const props = __props;
    const { name, size } = toRefs(props);
    const octicon = computed(() => {
      var _a;
      return (_a = octicons[name.value]) == null ? void 0 : _a.heights[size.value];
    });
    return (_ctx, _cache) => {
      return unref(octicon) ? (openBlock(), createElementBlock("svg", mergeProps({ key: 0 }, unref(octicon).options, {
        innerHTML: unref(octicon).path
      }), null, 16, _hoisted_1$2)) : createCommentVNode("", true);
    };
  }
});
var Dialog_vue_vue_type_style_index_0_scoped_true_lang = "";
const stack = ref([]);
const _sfc_main$2 = defineComponent({
  name: "Dialog",
  components: {
    Octicon: _sfc_main$3
  },
  props: {
    modelValue: {
      type: Boolean,
      default: false
    }
  },
  setup(props, { emit }) {
    const { modelValue } = toRefs(props);
    const close = () => emit("update:modelValue", false);
    const id = `${Date.now()}${Math.random()}`;
    function handleEsc({ key }) {
      if (key === "Escape" && stack.value[stack.value.length - 1] === id) {
        close();
      }
    }
    watch(modelValue, (isOpen) => {
      if (isOpen) {
        stack.value.push(id);
        document.addEventListener("keydown", handleEsc);
      } else {
        stack.value.pop();
        document.removeEventListener("keydown", handleEsc);
      }
    }, { immediate: true });
    onBeforeUnmount(() => {
      document.removeEventListener("keydown", handleEsc);
    });
    return {
      modelValue,
      close
    };
  }
});
function _sfc_render$1(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_Octicon = resolveComponent("Octicon");
  return _ctx.modelValue ? (openBlock(), createElementBlock("div", {
    key: 0,
    class: "Dialog p-3",
    onClick: _cache[2] || (_cache[2] = (...args) => _ctx.close && _ctx.close(...args))
  }, [
    createElementVNode("div", {
      class: "Box Box--overlay anim-scale-in",
      onClick: _cache[1] || (_cache[1] = withModifiers(() => {
      }, ["stop"]))
    }, [
      renderSlot(_ctx.$slots, "default", {}, void 0, true),
      createElementVNode("button", {
        class: "close-button",
        onClick: _cache[0] || (_cache[0] = withModifiers((...args) => _ctx.close && _ctx.close(...args), ["prevent", "stop"]))
      }, [
        createVNode(_component_Octicon, { name: "x" })
      ])
    ])
  ])) : createCommentVNode("", true);
}
var Dialog = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["render", _sfc_render$1], ["__scopeId", "data-v-ec5e5928"]]);
const _sfc_main$1 = defineComponent({
  name: "Dropdown",
  props: {
    modelValue: {
      default: false,
      required: false
    },
    direction: {
      type: String,
      validator: (v) => ["ne", "e", "se", "s", "sw", "w", "nw"].includes(v),
      default: "sw"
    },
    menuClass: {
      type: String,
      required: false
    }
  },
  setup(props, { emit }) {
    const { modelValue } = toRefs(props);
    const detailsRef = ref();
    watch(modelValue, (v) => {
      var _a, _b;
      if (v) {
        (_a = detailsRef.value) == null ? void 0 : _a.setAttribute("open", true);
      } else {
        (_b = detailsRef.value) == null ? void 0 : _b.removeAttribute("open");
      }
    }, { immediate: true });
    function handleToggle() {
      var _a;
      emit("update:modelValue", (_a = detailsRef.value) == null ? void 0 : _a.open);
    }
    return {
      detailsRef,
      handleToggle
    };
  }
});
const _hoisted_1$1 = {
  "aria-haspopup": "true",
  style: { "cursor": "inherit" }
};
const _hoisted_2$1 = /* @__PURE__ */ createElementVNode("div", { class: "dropdown-caret" }, null, -1);
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("details", mergeProps(_ctx.$attrs, {
    ref: "detailsRef",
    class: "Dropdown dropdown details-reset details-overlay",
    onToggle: _cache[0] || (_cache[0] = (...args) => _ctx.handleToggle && _ctx.handleToggle(...args))
  }), [
    renderSlot(_ctx.$slots, "summary", {}, () => [
      createElementVNode("summary", _hoisted_1$1, [
        renderSlot(_ctx.$slots, "text"),
        _hoisted_2$1
      ])
    ]),
    createElementVNode("div", {
      class: normalizeClass(["dropdown-menu", `dropdown-menu-${_ctx.direction} ${_ctx.menuClass}`])
    }, [
      renderSlot(_ctx.$slots, "default")
    ], 2)
  ], 16);
}
var Dropdown = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render]]);
var Toast_vue_vue_type_style_index_0_scoped_true_lang = "";
const _hoisted_1 = {
  key: 0,
  class: "ToastContainer position-fixed bottom-0 right-0"
};
const _hoisted_2 = { class: "Toast-icon" };
const _hoisted_3 = { class: "Toast-content" };
function useToast() {
  const state = reactive({
    isOpen: false,
    message: "",
    type: "",
    timeout: void 0
  });
  function toast(message, type, timeout) {
    state.isOpen = false;
    setTimeout(() => {
      state.message = message || "";
      if (type)
        state.type = type;
      state.timeout = timeout;
      state.isOpen = Boolean(message);
    });
  }
  function error(error2, timeout) {
    var _a;
    toast(((_a = error2 == null ? void 0 : error2.getMessage) == null ? void 0 : _a.call(error2)) || (error2 == null ? void 0 : error2.message) || error2, "error", timeout);
  }
  return {
    state,
    toast,
    error
  };
}
const _sfc_main = /* @__PURE__ */ defineComponent({
  props: {
    modelValue: {
      type: Boolean,
      default: false
    },
    type: {
      type: String,
      default: "",
      validator: (v) => ["", "success", "warning", "error"].includes(v)
    },
    timeout: {
      type: Number,
      default: 5e3
    }
  },
  emits: [
    "update:modelValue"
  ],
  setup(__props, { emit }) {
    const props = __props;
    const { modelValue, type, timeout } = toRefs(props);
    function handleClose() {
      emit("update:modelValue", false);
    }
    const icon = computed(() => {
      const icons = {
        success: "check",
        warning: "alert",
        error: "stop"
      };
      return icons[type.value] || "info";
    });
    const color = computed(() => {
      const icons = {
        success: "success",
        warning: "attention",
        error: "danger"
      };
      return icons[type.value] || "accent";
    });
    const toastTimeout = ref();
    watch(modelValue, (v) => {
      window.clearTimeout(toastTimeout.value);
      if (v && timeout.value) {
        toastTimeout.value = window.setTimeout(() => {
          handleClose();
        }, timeout.value);
      }
    }, { immediate: true });
    onBeforeUnmount(() => {
      window.clearTimeout(toastTimeout.value);
    });
    return (_ctx, _cache) => {
      return unref(modelValue) ? (openBlock(), createElementBlock("aside", _hoisted_1, [
        createElementVNode("div", {
          class: normalizeClass(["Toast position-relative overflow-hidden anim-fade-up", `Toast--${unref(type)}`])
        }, [
          createElementVNode("span", _hoisted_2, [
            createVNode(_sfc_main$3, { name: unref(icon) }, null, 8, ["name"])
          ]),
          createElementVNode("div", _hoisted_3, [
            renderSlot(_ctx.$slots, "default", {}, void 0, true),
            unref(timeout) ? (openBlock(), createElementBlock("div", {
              key: 0,
              class: normalizeClass(["position-absolute left-0 right-0 bottom-0 anim-grow-x", `color-bg-${unref(color)}-emphasis`]),
              style: normalizeStyle({ animationDuration: `${unref(timeout)}ms` })
            }, null, 6)) : createCommentVNode("", true)
          ]),
          createElementVNode("button", {
            class: "Toast-dismissButton",
            onClick: handleClose
          }, [
            createVNode(_sfc_main$3, { name: "x" })
          ])
        ], 2)
      ])) : createCommentVNode("", true);
    };
  }
});
var Toast = /* @__PURE__ */ _export_sfc(_sfc_main, [["__scopeId", "data-v-1e8bc8a1"]]);
export { ActionListItem, Button, Dialog, Dropdown, _sfc_main$3 as Octicon, _sfc_main$5 as Spinner, Toast, useToast };
